volatile __eeprom u16 ee_adc[2] @8;
volatile __eeprom u8  ee_cnt[2] @8 + sizeof ee_adc;

volatile __eeprom u16 ee_dbg [50/2];

void write_ee_adc(u16 val)
{
 ee_adc[0] = val;
 ee_adc[1] = ~val;
}

void write_ee_cnt(u8 cnt)
{
 ee_cnt[0] = cnt;
 ee_cnt[1] = ~cnt;
}

bool check_ee(void)
{
 bool retval = true;
 u16 tmp;

 tmp = ee_adc[1];
 tmp = ~tmp;
 if(tmp != ee_adc[0]) retval = false;

 tmp = ee_cnt[1];
 tmp = ~tmp;
 if(tmp != ee_cnt[0]) retval = false;

 return retval;
}

void erase_storage(void)
{
 for(u8 i=0; i < 64; i++) *((__eeprom u8*)i) = 0x00;
}

