/********************************************************
Workspace: IAR AVR 6.50
Chip type: TINY13
High fuse: 0xFB
Low fuse : 0x6A
Project  :  
Date     : Oct, 2023
Version  : 0
*********************************************************/
#include <ioavr.h>
#include <intrinsics.h>

#include "defines.c"
#include "periph_init.c"
#include "misc.c"
#include "beep.c"
#include "ee_func.c"

#include "interrupts.c"


void devcon();

void main()
{
 static u16 beep_timer;

 cfg.gpio();
 cfg.acmp();
 cfg.iwdg();

 *((u8*)&flg) = 0;

 __enable_interrupt();

 beep(&beep_timer);

  //,         
 if(check_ee()==true)
 {
  //       
  //         
  //     
  if(*ee_cnt >= EE_ADC_M) flg.EE_RDY = true;
 }

 m:
 {
  if(beep_timer)
  {
   beep_timer--;

   LED_OFF;

   beep_processing(beep_timer);
  }
  else // 2
  {
   cfg.t0_clc();

   if(flg.TDIV == true) flg.TDIV = false;
   else // 1
   {
    static u16 time_cntdn = MC_FRQ/2 * MAX_TIME;

    flg.TDIV = true;

   tm:
    if(time_cntdn)
    {
     time_cntdn--;
     cfg.adc(true);
     REL_ON;
     LED_BLINK; // 

     //  
     {
      u16 adc_val;

      //  
      {
       while(ADCSRA & (1<<ADSC))continue;

       MCUCR = 1<<SE | 1<<SM0; //noise reduction mode
       __sleep();              //  

       adc_val  = ADCL;
       adc_val |= ADCH<<8;

       cfg.adc(false);
      }

      //         
      //        

      static u8 adc_cnt  = 0; //  
      static u16 adc_min = 0xffff; //

      //    
      {
       if(adc_val < ADC_MIN || adc_val > ADC_MAX)
       {
//       if(flg.SMSS == false) flg.SMSS = true;
//       else
//       {
        z:

        for(volatile u16 i=5E3;i;i--) continue;

        LED_BLINK;
        REL_OFF;

        __watchdog_reset();
        goto z;
//       }
       }
//      else flg.SMSS = false;
      }

      //     
      if(adc_val < adc_min)
      {
       adc_cnt = 0;

       //        
       adc_min = adc_val;
      }
      //            
      //        ,     
      else
      {
       //          
       if(time_cntdn > MC_FRQ/2 * MAX_TIME - STCNT)
       {
        adc_cnt = 0;

        //  eeprom        
        //           
        if(flg.EE_RDY == true)
        {
         if(flg.INIT_DL == false)
         {
          flg.INIT_DL = true;

          if(adc_val < ee_adc[0] + 10) time_cntdn = MC_FRQ/2 * MAX_TIME - STCNT;
         }
        }
       }
       //        
       else if(adc_cnt < ADCCNT)
       {
        adc_cnt++;
       }
       //       
       else
       {
        //  eeprom      eeprom
        {
         //      prom  
         if(check_ee()==true)
         {
          //       
          // 
          if(adc_val > *ee_adc + ADC_DIFF || adc_val < *ee_adc - ADC_DIFF)
          {
           //       
           if(*ee_cnt)
           {
            u8 tmp = *ee_cnt;
            tmp--;
            write_ee_cnt(tmp);
           }
           //       
           else
           {
            write_ee_adc(adc_val);
           }
          }
          //         
          //        
          else
          {
           if(*ee_cnt < EE_ADC_M)
           {
            u8 tmp = *ee_cnt;
            tmp++;
            write_ee_cnt(tmp);

            write_ee_adc(adc_val + *ee_adc >>1);
           }
          }
         }
         //    -       = 0
         else
         {
          write_ee_adc(adc_val);
          write_ee_cnt(0);
         }
        }

        time_cntdn = 0; //        

        goto tm; //     
       }
      }
     }
    }
    else  // 
    {
     if(flg.END_BEEP == false) //   
     {
      REL_OFF;

      flg.TDIV = false; //    2,        0,5

      if(!flg.BEEP_TRG)
      {
       flg.BEEP_TRG = true;

       beep(&beep_timer);
      }
      else
      {
       static u8 beep_num = 3;

       flg.BEEP_TRG = false;
       beep_num--;

       if(!beep_num)
       {
        flg.END_BEEP = true;

        LED_ON;
       }
      }
     }
    }
   }

   __watchdog_reset();
  }

   MCUCR = 1<<SE; //idle mode
   __sleep();     //  
 }

 goto m;
}


